﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Runtime.InteropServices;


namespace CSClsLib
{
    public delegate void EventStep(object sender, StepEventArgs e);

    [ComVisible(true)]
    public class StepEventArgs : EventArgs
    {
        public int count { get; protected set; }
        public StepEventArgs(int count)
        {
            this.count = count;
        }
    }

    [ComVisible(true)]
    [Guid("A3467FAD-AB4C-4884-BCE1-7C32F424D412")]
    [InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
    public interface StepEvent
    {
        void EventStep(object sender, StepEventArgs args);
    }

    [ComVisible(true)]
    [Guid("366218FB-4869-4DB8-903A-FC6A9F2EEB1E")]
    [ProgId("CSClsLib.ClsSample")]
    [ClassInterface(ClassInterfaceType.AutoDual)]
    [ComSourceInterfaces(typeof(StepEvent))]
    public class ClsSample
    {
        public event EventStep eventStep;
        public string status {get; protected set;}
        public void RunWork([MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] 
            object[] arg)
        {
            this.status = Convert.ToString(arg[0]);
            int maxCount = Convert.ToInt32(arg[1]);
            for (int count = 0; count < maxCount; count++)
            {
                OnEventStep(new StepEventArgs(count));
            }
        }

        protected void OnEventStep(StepEventArgs args)
        {
            if (eventStep != null)
            {
                eventStep(this, args);
            }
        }
    }
}
