﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CSClsLibEx
{
    public partial class ProgressDlg : Form
    {
        public delegate void ProgressBarResetValue(object sender, int newValue, bool completed);
        public delegate void CloseForm(object sender);
        ClsSampleEx clsSampleEx;

        private ProgressDlg()
        {
            InitializeComponent();
            btnCancel.Select(); 
        }

        public ProgressDlg(ClsSampleEx clsSampleEx)
        {
            this.clsSampleEx = clsSampleEx;
            InitializeComponent();
            btnCancel.Select(); 
        }

        public void ResetProgressBar(object sender, int value, bool completed)
        {
            try
            {
                if (progressBar.InvokeRequired)
                {
                    progressBar.BeginInvoke(
                        new ProgressBarResetValue(ProgressBarResetValueMethod),
                        new object[] { sender, value, completed });
                }
                else
                {
                    if (value <= progressBar.Maximum)
                    {
                        progressBar.Value = value;
                    }
                }
            }
            catch { }
        }

        void ProgressBarResetValueMethod(object sender, int newValue, bool completed)
        {
            if (newValue <= progressBar.Maximum)
            {
                progressBar.Value = newValue;
            }
        }

        public void CloseEx(object sender)
        {
            try
            {
                BeginInvoke(new CloseForm(CloseFormMethod), new object[] { sender });
            }
            catch { }
        }

        void CloseFormMethod(object sender)
        {
            Close();
        }

        private void OnBtnCancel_Click(object sender, EventArgs e)
        {
            if (clsSampleEx != null)
            {
                clsSampleEx.Terminate(); 
            }
            Close();
        }
    }
}
