﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Runtime.InteropServices;
using System.Threading;
using VisualFoxpro;

namespace CSClsLibVfp
{
    [ComVisible(true)]
    [Guid("B6FCD7CD-CB65-442F-84DC-8C85F8182ED6")]
    [ProgId("CSClsLibVfp.TestVfpApp")]
    [ClassInterface(ClassInterfaceType.AutoDual)]
    public class TestVfpApp
    {
        const int THREAD_SLEEP = 100;
        ThreadInfo threadInfo;
        EventHandler threadCompleted;

        public void RunWork([MarshalAs(UnmanagedType.SafeArray, SafeArraySubType = VarEnum.VT_VARIANT)] 
            object[] arg)
        {
            this.threadInfo = new ThreadInfo(arg);
            this.threadInfo.thread = new Thread(RunWorkEx);
            this.threadInfo.thread.SetApartmentState(ApartmentState.STA);
            this.threadCompleted = new EventHandler(ThreadCompleted);
            this.threadInfo.thread.Start(threadInfo);
            while (!this.threadInfo.thread.IsAlive)
            {
                Thread.Sleep(0);
            }
        }

        void RunWorkEx(object objThreadInfo)
        {
            int count = 0;
            int maxCount = (-1);
            ThreadInfo threadInfo = null;
            Application vfpApp = null;
            object objFormInd = 1;

            try
            {
                if ((threadInfo = objThreadInfo as ThreadInfo) == null)
                {
                    throw new NullReferenceException("threadInfo");
                }
                vfpApp = threadInfo.arg[0] as Application;
                if (vfpApp == null)
                {
                    throw new ArgumentNullException("threadInfo.arg[0] as Application");
                }
                if ((maxCount = Convert.ToInt32(threadInfo.arg[1])) <= 0)
                {
                    throw new ArgumentOutOfRangeException("threadInfo.arg[1] = " + maxCount);
                }
                for (; count < maxCount; count++)
                {
                    try
                    {
                        vfpApp.Forms[objFormInd].ProgressValue = count;
                        Thread.Sleep(THREAD_SLEEP);
                    }
                    catch 
                    {
                        break; 
                    }
                }
            }
            finally
            {
                try
                {
                    vfpApp.Forms[objFormInd].Release();
                }
                catch { }
                this.threadCompleted.BeginInvoke(this, new EventArgs(), null, null);
            }
        }

        void ThreadCompleted(object sender, EventArgs e)
        {
            while (this.threadInfo.thread != null
                && this.threadInfo.thread.IsAlive)
            {
                Thread.Sleep(0);
            }
            if (this.threadInfo.thread != null)
            {
                this.threadInfo.thread.Join();
                this.threadInfo.thread = null;
            }
        }
    }
 
    public class ThreadInfo
    {
        public object[] arg { get; protected set; }
        public Thread thread { get; set; }

        public ThreadInfo(object[] arg)
        {
            this.arg = new object[arg.Length];
            arg.CopyTo(this.arg, 0);
        }
    }
}
